import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import React, { useCallback } from 'react';
import { View, Image } from '@ray-js/ray';
import clsx from 'clsx';
import './index.less';
import { defaultProps } from './props';
import Transition, { TransitionName } from './transition';
var classPrefix = 'ray-popup';
function toTransactionName(placement) {
  if (placement === 'center') {
    return TransitionName.Fade;
  }
  if (placement === 'top') {
    return TransitionName.SlideDown;
  }
  if (placement === 'bottom') {
    return TransitionName.SlideUp;
  }
  if (placement === 'right') {
    return TransitionName.SlideRight;
  }
  if (placement === 'left') {
    return TransitionName.SlideLeft;
  }
  return TransitionName.Fade;
}
var Popup = function (props) {
  var _clsx2, _clsx3;
  var children = props.children,
    className = props.className,
    show = props.show,
    duration = props.duration,
    zIndex = props.zIndex,
    overlay = props.overlay,
    closeOnClickOverlay = props.closeOnClickOverlay,
    position = props.position,
    round = props.round,
    overlayStyle = props.overlayStyle,
    customStyle = props.customStyle,
    onClickOverlay = props.onClickOverlay,
    closeable = props.closeable,
    closeIcon = props.closeIcon,
    closeIconPosition = props.closeIconPosition,
    closeIconStyle = props.closeIconStyle,
    onClose = props.onClose,
    safeAreaInsetBottom = props.safeAreaInsetBottom,
    safeAreaInsetTop = props.safeAreaInsetTop;
  var transactionName = toTransactionName(position);
  var _onClickOverlay = useCallback(function (event) {
    onClickOverlay === null || onClickOverlay === void 0 ? void 0 : onClickOverlay(event);
    if (closeOnClickOverlay) {
      onClose === null || onClose === void 0 ? void 0 : onClose(event);
    }
  }, [closeOnClickOverlay, onClickOverlay, onClose]);
  var _onClickCloseIcon = useCallback(function (event) {
    onClose === null || onClose === void 0 ? void 0 : onClose(event);
  }, [onClose]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Transition, {
    in: show,
    name: transactionName,
    timeout: duration
  }, /*#__PURE__*/React.createElement(View, {
    className: clsx(classPrefix, _defineProperty({}, "".concat(classPrefix, "--round"), round), (_clsx2 = {}, _defineProperty(_clsx2, "".concat(classPrefix, "--center"), position === 'center'), _defineProperty(_clsx2, "".concat(classPrefix, "--top"), position === 'top'), _defineProperty(_clsx2, "".concat(classPrefix, "--right"), position === 'right'), _defineProperty(_clsx2, "".concat(classPrefix, "--bottom"), position === 'bottom'), _defineProperty(_clsx2, "".concat(classPrefix, "--left"), position === 'left'), _clsx2), (_clsx3 = {}, _defineProperty(_clsx3, "".concat(classPrefix, "--safeBottom"), safeAreaInsetBottom), _defineProperty(_clsx3, "".concat(classPrefix, "--safeTop"), safeAreaInsetTop), _clsx3), className),
    style: _objectSpread(_objectSpread({}, customStyle), {}, {
      zIndex: zIndex + 10
    })
  }, children, closeable ? /*#__PURE__*/React.createElement(View, {
    className: clsx("".concat(classPrefix, "__close-icon"), "".concat(classPrefix, "__close-icon--").concat(closeIconPosition)),
    style: {
      zIndex: zIndex + 10
    },
    onClick: _onClickCloseIcon
  }, /*#__PURE__*/React.createElement(Image, {
    src: closeIcon,
    style: _objectSpread({
      width: '24px',
      height: '24px'
    }, closeIconStyle)
  })) : null)), overlay ? /*#__PURE__*/React.createElement(Transition, {
    in: show,
    name: TransitionName.Fade,
    timeout: duration
  }, /*#__PURE__*/React.createElement(View, {
    style: _objectSpread(_objectSpread({}, overlayStyle), {}, {
      zIndex: zIndex
    }),
    className: "".concat(classPrefix, "--overlay"),
    onClick: _onClickOverlay
  })) : null);
};
Popup.defaultProps = defaultProps;
Popup.displayName = 'Popup';
export default Popup;