import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["className", "style"];
/* eslint-disable no-return-assign */
import React, { useEffect, isValidElement, useMemo, useState } from 'react';
import { View } from '@ray-js/ray';
import clsx from 'clsx';
import './transition.less';
export var TransitionName;
(function (TransitionName) {
  TransitionName["Fade"] = "fade";
  TransitionName["SlideUp"] = "slide-up";
  TransitionName["SlideDown"] = "slide-down";
  TransitionName["SlideLeft"] = "slide-left";
  TransitionName["SlideRight"] = "slide-right";
})(TransitionName || (TransitionName = {}));
function useElementProps(children) {
  return useMemo(function () {
    var _element$props;
    if (! /*#__PURE__*/isValidElement(children)) {
      return {};
    }
    return (_element$props = children.props) !== null && _element$props !== void 0 ? _element$props : {};
  }, [children]);
}
var Transition = function (props) {
  var _clsx;
  var name = props.name,
    inProp = props.in,
    timeout = props.timeout,
    childrenProp = props.children;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    status = _useState2[0],
    setStatus = _useState2[1];
  useEffect(function () {
    if (inProp) {
      setStatus('enter');
      setTimeout(function () {
        setStatus('entered');
      }, timeout);
    } else {
      if (status === '' || status === 'exit') return;
      setStatus('exit');
      setTimeout(function () {
        setStatus('exited');
      }, timeout);
    }
  }, [inProp]);
  var children = useMemo(function () {
    return childrenProp;
  }, [childrenProp]);
  var _useElementProps = useElementProps(children),
    childrenClassName = _useElementProps.className,
    childrenStyle = _useElementProps.style,
    childrenProps = _objectWithoutProperties(_useElementProps, _excluded);
  return /*#__PURE__*/React.createElement(View, _extends({
    style: _objectSpread(_objectSpread({}, childrenStyle), {}, {
      animationDuration: "".concat(timeout, "ms"),
      display: status === 'exited' || status === '' ? 'none' : childrenStyle === null || childrenStyle === void 0 ? void 0 : childrenStyle.display
    }),
    className: clsx(childrenClassName, (_clsx = {}, _defineProperty(_clsx, name, status === 'enter' || status === 'exit'), _defineProperty(_clsx, "".concat(name, "-enter"), status === 'enter'), _defineProperty(_clsx, "".concat(name, "-enter-active"), status === 'enter'), _defineProperty(_clsx, "".concat(name, "-enter-done"), status === 'entered'), _defineProperty(_clsx, "".concat(name, "-exit"), status === 'exit'), _defineProperty(_clsx, "".concat(name, "-exit-active"), status === 'exit'), _defineProperty(_clsx, "".concat(name, "-exit-done"), status === 'exited'), _clsx))
  }, childrenProps));
};
Transition.defaultProps = {
  name: TransitionName.Fade,
  in: false,
  timeout: 300
};
export default Transition;